# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from .......core.pydantic_utilities import UniversalBaseModel
from .request_schema import RequestSchema
from .schema_property import SchemaProperty
from .api_type import ApiType
import pydantic
import typing
from .route import Route
from .security_scheme_name import SecuritySchemeName
from .security_scheme import SecurityScheme
from .security_requirement import SecurityRequirement
from ..graphql.graph_ql_query import GraphQlQuery
from .......core.pydantic_utilities import IS_PYDANTIC_V2
from .......core.pydantic_utilities import update_forward_refs


class RoutesReport(UniversalBaseModel):
    target: str
    app_type: ApiType = pydantic.Field(alias="appType")
    base_endpoint_url: str = pydantic.Field(alias="baseEndpointUrl")
    version: typing.Optional[str] = None
    schema_url: typing.Optional[str] = pydantic.Field(alias="schemaUrl", default=None)
    routes: typing.Optional[typing.List[Route]] = None
    security_schemes: typing.Optional[typing.Dict[SecuritySchemeName, SecurityScheme]] = pydantic.Field(
        alias="securitySchemes", default=None
    )
    security: typing.Optional[typing.List[SecurityRequirement]] = None
    queries: typing.Optional[typing.List[GraphQlQuery]] = None
    raw: str
    errors: typing.Optional[typing.List[str]] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            extra = pydantic.Extra.allow


update_forward_refs(RequestSchema, RoutesReport=RoutesReport)
update_forward_refs(SchemaProperty, RoutesReport=RoutesReport)
